var y=1; // 1 - chrome 5 - firefox

var isFirefox=(navigator.userAgent.toLowerCase().indexOf('firefox') > -1);
var isChrome = navigator.userAgent.indexOf("Chrome") != -1;

if (isFirefox) y=5;

LoadOption=function(name,def)
{
var load=localStorage.getItem(name)
if (load===null) return def;
return load;
}


var c = document.createElement("canvas").getContext("2d");
 c.width = c.height = 19;

var fullIcons=["00","01","02","03","04","05","06"];

function setIcon(tabid, imgpath) {
    var o = new Image;
    o.onload = function() {
        c.clearRect(0, 0, c.width, c.height); 
	c.fillStyle="silver";
	if (fullIcons.indexOf(imgpath)==-1) c.fillRect(0,y-1,19,15);
	c.drawImage(o, 1, y, o.width, o.height); 
	chrome.browserAction.setIcon({
            tabId: tabid,
            imageData: c.getImageData(0, 0, 19, 19)
        });
    };
o.src = "/flags/" + imgpath.toLowerCase() + ".png";
}

showAll=function(msg,tabId)
{
if (!msg.flag) return;
if (msg.flag==="00") return;
setIcon(tabId,msg.flag);
if (fullIcons.indexOf(msg.flag)==-1) chrome.browserAction.setBadgeText({text: msg.flag, tabId : tabId });

var title=msg.country
if (msg.IPs)
{ title+="\n"
for (let i in msg.IPs) title+="\n"+msg.IPs[i].ip
}
chrome.browserAction.setTitle({ title : title, tabId : tabId });
}

function IsSoundFilter(msg)
{
var sSoundFilter=LoadOption('SoundFilter',"");
if (sSoundFilter==="") return true;
var fields=sSoundFilter.toLowerCase().split(',');

for (let i in fields) 
	if (fields[i].trim()!=="") 
		fields[i]='"' + fields[i]

var obj=JSON.stringify(msg).toLowerCase()
for (let i in fields) 
	{
	if (fields[i].trim()!=="") 
		if (obj.indexOf(fields[i].trim())!=-1) return false;
	}
return true
}

function SoundAll(msg)
{
if (msg && isChrome)
	{
        if (msg.flag==="00") return;
	if (IsSoundFilter(msg))
		chrome.tts.speak(msg.country);
	}
}

var msgs=[]; // ip address responses

chrome.tabs.onActivated.addListener(function(info) {
        if (msgs[info.tabId]) 
		{
		showAll(msgs[info.tabId],info.tabId);
		var Option=LoadOption('SoundChange',"1");
		if (Option==="1") SoundAll(msgs[info.tabId]);
		}
});

function FlagUrl(tabId, tab)
{
chrome.runtime.sendNativeMessage('com.johnsecurity.activewhois',{address: tab.url},function(msg) {
			msgs[tabId]=msg;
			showAll(msgs[tabId],tabId);
			//console.log(msg);
			if (msg)
				{
				var Option=LoadOption('SoundMake',"1");
				if (Option==="1") SoundAll(msg);
				}
	});
}

FlagUpdater=function(tabId, changeInfo, tab)
{
if (changeInfo.status === "loading")
	{
	var FlagMode=LoadOption('flagwork',"always");
	if (FlagMode==="always") {FlagUrl(tabId,tab); return;}
	if (FlagMode==="off") return;
	}
}

chrome.tabs.onUpdated.addListener(FlagUpdater)

